/*
 * startdvdhde.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */

#include <vdr/plugin.h>
#include <vdr/remote.h>
#include <string>
#include <vector>

static const char *VERSION        = "0.0.1";
static const char *DESCRIPTION    = "Start DVD with xinemediaplayer-plugin";
static const char *MAINMENUENTRY  = "DVD";

class cPluginStartdvdhde : public cPlugin {
private:
  // Add any member variables or functions you may need here.
public:
  cPluginStartdvdhde(void);
  virtual ~cPluginStartdvdhde();
  virtual const char *Version(void) { return VERSION; }
  virtual const char *Description(void) { return DESCRIPTION; }
  virtual const char *CommandLineHelp(void);
  virtual bool ProcessArgs(int argc, char *argv[]);
  virtual bool Initialize(void);
  virtual bool Start(void);
  virtual void Stop(void);
  virtual void Housekeeping(void);
  virtual void MainThreadHook(void);
  virtual cString Active(void);
  virtual time_t WakeupTime(void);
  virtual const char *MainMenuEntry(void) { return MAINMENUENTRY; }
  virtual cOsdObject *MainMenuAction(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual bool SetupParse(const char *Name, const char *Value);
  virtual bool Service(const char *Id, void *Data = NULL);
  virtual const char **SVDRPHelpPages(void);
  virtual cString SVDRPCommand(const char *Command, const char *Option, int &ReplyCode);
  };

cPluginStartdvdhde::cPluginStartdvdhde(void)
{
  // Initialize any member variables here.
  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!
}

cPluginStartdvdhde::~cPluginStartdvdhde()
{
  // Clean up after yourself!
}

const char *cPluginStartdvdhde::CommandLineHelp(void)
{
  // Return a string that describes all known command line options.
  return NULL;
}

bool cPluginStartdvdhde::ProcessArgs(int argc, char *argv[])
{
  // Implement command line argument processing here if applicable.
  return true;
}

bool cPluginStartdvdhde::Initialize(void)
{
  // Initialize any background activities the plugin shall perform.
  return true;
}

bool cPluginStartdvdhde::Start(void)
{
  // Start any background activities the plugin shall perform.
  return true;
}

void cPluginStartdvdhde::Stop(void)
{
  // Stop any background activities the plugin is performing.
}

void cPluginStartdvdhde::Housekeeping(void)
{
  // Perform any cleanup or other regular tasks.
}

void cPluginStartdvdhde::MainThreadHook(void)
{
  // Perform actions in the context of the main program thread.
  // WARNING: Use with great care - see PLUGINS.html!
}

cString cPluginStartdvdhde::Active(void)
{
  // Return a message string if shutdown should be postponed
  return NULL;
}

time_t cPluginStartdvdhde::WakeupTime(void)
{
  // Return custom wakeup time for shutdown script
  return 0;
}

cOsdObject *cPluginStartdvdhde::MainMenuAction(void)
{
  // Perform the action when selected from the main VDR menu.
  cRemote::CallPlugin("xinemediaplayer");
  std::vector<std::string> playlistEntries; //empty list
  struct
  {
    char const *mrl;
    bool playlist;
    std::vector<std::string> playlistEntries;
  } xinePlayData  =
  {
    "dvd://", 
    false,
    playlistEntries	
  };
  cPluginManager::CallAllServices("Xine Play mrl", &xinePlayData);
  
  return NULL;
}

cMenuSetupPage *cPluginStartdvdhde::SetupMenu(void)
{
  // Return a setup menu in case the plugin supports one.
  return NULL;
}

bool cPluginStartdvdhde::SetupParse(const char *Name, const char *Value)
{
  // Parse your own setup parameters and store their values.
  return false;
}

bool cPluginStartdvdhde::Service(const char *Id, void *Data)
{
  // Handle custom service requests from other plugins
  return false;
}

const char **cPluginStartdvdhde::SVDRPHelpPages(void)
{
  // Return help text for SVDRP commands this plugin implements
  return NULL;
}

cString cPluginStartdvdhde::SVDRPCommand(const char *Command, const char *Option, int &ReplyCode)
{
  // Process SVDRP commands this plugin implements
  return NULL;
}

VDRPLUGINCREATOR(cPluginStartdvdhde); // Don't touch this!
